#include "sqp.h"

/*
 * HOPEFULLY CLEANS UP A FAILED PARSE (if it did fail)
 *
 */
void sqpClose()
{

#ifdef SQPDEBUG
	printf( "[SQP][%s][%d] BEGIN:\n", __FILE__, __LINE__ );
#endif

	*g_szError		= '\0';

    /* 
     * This should only do it if sqpParse worked but the caller did
     * not adopt the result.
     *
     */
    if ( sqpFreeParsedSQL( g_hParsedSQL ) )
    {
        g_hParsedSQL = NULL;
#ifdef SQPDEBUG
    	printf( "[SQP][%s][%d] END: Appears that parse made it to top level struct and it has been freed ok.\n", __FILE__, __LINE__ );
#endif
        return;
    }

    /*
     * Free any work in progress (sql parts which never made it into 
     * a parent struct). This is required only when a sqpParse fails
     * but we can safely do it in anycase by checking for values before
     * calling free.
     *
     */
    if ( g_pszTable )
        free(g_pszTable);

    if ( g_pszType )
        free(g_pszType);

    if ( g_hColumnDefs )
    {
        lstSetFreeFunc( g_hColumnDefs, sqpFreeColumnDef );
        lstClose( g_hColumnDefs );
    }
    if ( g_hDataType )
    {
        sqpFreeDataType( g_hDataType );
    }
    if ( g_hColumns )
    {
        lstSetFreeFunc( g_hColumns, sqpFreeColumn );
        lstClose( g_hColumns );
    }
    if ( g_hComparisons )
    {
        lstSetFreeFunc( g_hComparisons, sqpFreeComparison );
        lstClose( g_hComparisons );
    }
    if ( g_hValues )
        lstClose( g_hValues );

    if ( g_hAssignments	)
    {
        lstSetFreeFunc( g_hAssignments, sqpFreeAssignment );
        lstClose( g_hAssignments );
    }
    if ( g_hOrderBy )
    {
        lstSetFreeFunc( g_hOrderBy, sqpFreeColumn );
        lstClose( g_hOrderBy );
    }
    if ( g_pszCursor )
        free(g_pszCursor);

#ifdef SQPDEBUG
	printf( "[SQP][%s][%d] END: Attempted to free any work in progress.\n", __FILE__, __LINE__ );
#endif

}


